import math
import tensorflow as tf
import pathlib
import numpy as np
import sys
import io
import os
from keras.models import Model

sys.stdout = io.TextIOWrapper(sys.stdout.buffer, encoding='utf-8')

def output_model(the_model):
  w = 24
  l = len(the_model.layers)
  ll = 'Layer:'.ljust(w)
  il = 'Input Shape:'.ljust(w)
  ol = 'Output Shape'
  print(ll + il + ol)
  for i in range(l):
    n = type(the_model.layers[i]).__name__.ljust(w)
    ish = str(the_model.layers[i].input.shape).ljust(w)
    osh = str(the_model.layers[i].output.shape)
    print(n +  ':' + ish +  ':' + osh)

def getEventNumber(ev):
# REPLACE NEXT
  concatOffsets = [CONCAT_OFFSETS]
  if len(concatOffsets) == 0:
    return ev
  evt = ev
  for offset in concatOffsets:
    if evt - offset > 0:
      evt = evt - offset
    else:
      return evt
  return evt

def getImageFilePrefix(ev):
# REPLACE NEXT
  prefixes = [IMAGE_PREFIXES]
# REPLACE NEXT
  concatOffsets = [CONCAT_OFFSETS]
  pLen = len(prefixes)
  if pLen == 0:
    return 'UNKNOWN'
  evt = ev
  i = 0
  current = prefixes[i]
  for offset in concatOffsets:
    if evt - offset > 0:
      evt = evt - offset
      i = i + 1
      if (i < pLen):
        current = prefixes[i]
    else:
      return current
  return current

def writeDenseFeaturesRow(ev, fmap, denseFeaturesFile):
# if ev negative, image file does not exist
  for j in range(len(fmap)):
    if ev < 0:
      val = 0
    else:
      val = fmap[j] * 100
    denseFeaturesFile.write(str(val) + ", ")
#  denseFeaturesFile.write(str(ev))
  denseFeaturesFile.write("\n")

# REPLACE NEXT
img_height = IMAGE_HEIGHT
# REPLACE NEXT
img_width = IMAGE_WIDTH

numPerFolder = 10000

try:

# REPLACE NEXT
  model = tf.keras.models.load_model('SAVED_MODEL')
# model.summary()
  output_model(model)

  testImages = [ ]
  eventNums = []
# REPLACE NEXT
  prefix = "IMAGE_DIR"
# REPLACE NEXT
  imageExt = ".IMAGE_EXTENSION"

# REPLACE NEXT
  class_names = [ CLASS_NAMES ]

# REPLACE NEXT
  with open('TEST_EVENTS_FILE') as f:
    line = f.readline()
    line = f.readline()
    while line:
      evLine = line.split(',')
      evStr = evLine[-1]
      ev = int(evStr) - 1
      ev = getEventNumber(ev)
      evStr = str(ev)
      ev1 = math.floor(ev / numPerFolder) * numPerFolder
# REPLACE NEXT
      sub = "%0EVENT_FIELD_LENGTHd" % ev1
# REPLACE NEXT
      sub = sub.zfill(EVENT_FIELD_LENGTH)
# REPLACE NEXT
      evStr = evStr.zfill(EVENT_FIELD_LENGTH)

# REPLACE NEXT
      imagePath = prefix + getImageFilePrefix(ev) + evStr + "IMAGE_SUFFIX" + imageExt
      imageFile = pathlib.Path(imagePath)
      testImages.append(imageFile)
      eventNums.append(ev)
      line = f.readline()

  image_count = len(list(testImages))
  print('Number of images: ', end = '')
  print(image_count)

# REPLACE NEXT
  outFile = open("PROBABILITIES_OUT_FILE", "w")
  for i in range(len(class_names)):
    outFile.write(class_names[i] + ", ")
  outFile.write("\n")

# REPLACE NEXT
  doDenseFeatures = DO_DENSE_FEATURES
  if doDenseFeatures:
# REPLACE NEXT
    denseFeaturesFile = open("DENSE_FEATURES_OUT_FILE", "w")
    denseIndex = -1
    for i in range(len(model.layers) - 1):
      layerType = type(model.layers[i]).__name__
      denseIndex = i
    layer_outputs = [ layer.output for layer in model.layers ]
    numDenseFeatures = layer_outputs[denseIndex][0].shape[0]
    feature_map_model = Model(inputs=model.inputs, outputs=layer_outputs)
    for j in range(numDenseFeatures):
      denseFeaturesFile.write("Feature_" + str(j+1) + ", ")
    denseFeaturesFile.write("\n")

  for i in range(len(testImages)):
    im = testImages[i]
    ev = eventNums[i]
    try:
      img = tf.keras.utils.load_img( im, target_size=(img_height, img_width) )
      img_array = tf.keras.utils.img_to_array(img)
      img_array = tf.expand_dims(img_array, 0) # Create a batch

      if doDenseFeatures:
        feature_maps = feature_map_model.predict(img_array, verbose = 0)
        writeDenseFeaturesRow(ev, feature_maps[denseIndex][0], denseFeaturesFile)
        predictions = feature_maps[denseIndex+1]
      else:
        predictions = model.predict(img_array, verbose = 0)

      score = predictions[0]
    except Exception as inst1:
      score = []
      for j in range(len(class_names)):
        score.append(0)
      if doDenseFeatures:
        writeDenseFeaturesRow(-1, range(numDenseFeatures), denseFeaturesFile)

    for j in range(len(score)):
      outFile.write(str(score[j] * 100) + ", ")
    outFile.write("\n")

  outFile.close()
  if doDenseFeatures:
    denseFeaturesFile.close()

except Exception as inst:
  print('Exception in prediction script')
  print(type(inst))
  print(inst.args)
  print(inst)

else:
  print('Prediction script completed')

finally:
# REPLACE NEXT
  outFile = open("PROBABILITIES_OUT_FILE" + ".done", "w")
  outFile.close()
